#include "mozilla/EnumTypeTraits.h"
#include "mozilla/dom/BindingNames.h"

namespace mozilla::dom {

namespace binding_detail {

const char sBindingNames[] = {
  /*     0 */ "ANGLE_instanced_arrays" "\0"
  /*    23 */ "APZHitResultFlags" "\0"
  /*    41 */ "AbortController" "\0"
  /*    57 */ "AbortSignal" "\0"
  /*    69 */ "AbstractRange" "\0"
  /*    83 */ "AccessibleNode" "\0"
  /*    98 */ "Addon" "\0"
  /*   104 */ "AddonEvent" "\0"
  /*   115 */ "AddonInstall" "\0"
  /*   128 */ "AddonManager" "\0"
  /*   141 */ "AddonManagerPermissions" "\0"
  /*   165 */ "AnalyserNode" "\0"
  /*   178 */ "Animation" "\0"
  /*   188 */ "AnimationEffect" "\0"
  /*   204 */ "AnimationEvent" "\0"
  /*   219 */ "AnimationPlaybackEvent" "\0"
  /*   242 */ "AnimationTimeline" "\0"
  /*   260 */ "AnonymousContent" "\0"
  /*   277 */ "Attr" "\0"
  /*   282 */ "Audio" "\0"
  /*   288 */ "AudioBuffer" "\0"
  /*   300 */ "AudioBufferSourceNode" "\0"
  /*   322 */ "AudioContext" "\0"
  /*   335 */ "AudioDestinationNode" "\0"
  /*   356 */ "AudioListener" "\0"
  /*   370 */ "AudioNode" "\0"
  /*   380 */ "AudioParam" "\0"
  /*   391 */ "AudioParamMap" "\0"
  /*   405 */ "AudioProcessingEvent" "\0"
  /*   426 */ "AudioScheduledSourceNode" "\0"
  /*   451 */ "AudioTrack" "\0"
  /*   462 */ "AudioTrackList" "\0"
  /*   477 */ "AudioWorklet" "\0"
  /*   490 */ "AudioWorkletGlobalScope" "\0"
  /*   514 */ "AudioWorkletNode" "\0"
  /*   531 */ "AudioWorkletProcessor" "\0"
  /*   553 */ "AuthenticatorAssertionResponse" "\0"
  /*   584 */ "AuthenticatorAttestationResponse" "\0"
  /*   617 */ "AuthenticatorResponse" "\0"
  /*   639 */ "BarProp" "\0"
  /*   647 */ "BaseAudioContext" "\0"
  /*   664 */ "BatteryManager" "\0"
  /*   679 */ "BeforeUnloadEvent" "\0"
  /*   697 */ "BiquadFilterNode" "\0"
  /*   714 */ "Blob" "\0"
  /*   719 */ "BlobEvent" "\0"
  /*   729 */ "BroadcastChannel" "\0"
  /*   746 */ "BrowsingContext" "\0"
  /*   762 */ "BrowsingContextGroup" "\0"
  /*   783 */ "ByteLengthQueuingStrategy" "\0"
  /*   809 */ "CDATASection" "\0"
  /*   822 */ "CSS" "\0"
  /*   826 */ "CSS2Properties" "\0"
  /*   841 */ "CSSAnimation" "\0"
  /*   854 */ "CSSConditionRule" "\0"
  /*   871 */ "CSSContainerRule" "\0"
  /*   888 */ "CSSCounterStyleRule" "\0"
  /*   908 */ "CSSFontFaceRule" "\0"
  /*   924 */ "CSSFontFeatureValuesRule" "\0"
  /*   949 */ "CSSFontPaletteValuesRule" "\0"
  /*   974 */ "CSSGroupingRule" "\0"
  /*   990 */ "CSSImportRule" "\0"
  /*  1004 */ "CSSKeyframeRule" "\0"
  /*  1020 */ "CSSKeyframesRule" "\0"
  /*  1037 */ "CSSLayerBlockRule" "\0"
  /*  1055 */ "CSSLayerStatementRule" "\0"
  /*  1077 */ "CSSMediaRule" "\0"
  /*  1090 */ "CSSMozDocumentRule" "\0"
  /*  1109 */ "CSSNamespaceRule" "\0"
  /*  1126 */ "CSSPageRule" "\0"
  /*  1138 */ "CSSPropertyRule" "\0"
  /*  1154 */ "CSSPseudoElement" "\0"
  /*  1171 */ "CSSRule" "\0"
  /*  1179 */ "CSSRuleList" "\0"
  /*  1191 */ "CSSStyleDeclaration" "\0"
  /*  1211 */ "CSSStyleRule" "\0"
  /*  1224 */ "CSSStyleSheet" "\0"
  /*  1238 */ "CSSSupportsRule" "\0"
  /*  1254 */ "CSSTransition" "\0"
  /*  1268 */ "Cache" "\0"
  /*  1274 */ "CacheStorage" "\0"
  /*  1287 */ "CallbackDebuggerNotification" "\0"
  /*  1316 */ "CanonicalBrowsingContext" "\0"
  /*  1341 */ "CanvasCaptureMediaStream" "\0"
  /*  1366 */ "CanvasGradient" "\0"
  /*  1381 */ "CanvasPattern" "\0"
  /*  1395 */ "CanvasRenderingContext2D" "\0"
  /*  1420 */ "CaretPosition" "\0"
  /*  1434 */ "CaretStateChangedEvent" "\0"
  /*  1457 */ "ChannelMergerNode" "\0"
  /*  1475 */ "ChannelSplitterNode" "\0"
  /*  1495 */ "ChannelWrapper" "\0"
  /*  1510 */ "CharacterData" "\0"
  /*  1524 */ "CheckerboardReportService" "\0"
  /*  1550 */ "ChildProcessMessageManager" "\0"
  /*  1577 */ "ChildSHistory" "\0"
  /*  1591 */ "ChromeMessageBroadcaster" "\0"
  /*  1616 */ "ChromeMessageSender" "\0"
  /*  1636 */ "ChromeNodeList" "\0"
  /*  1651 */ "ChromeUtils" "\0"
  /*  1663 */ "ChromeWorker" "\0"
  /*  1676 */ "Client" "\0"
  /*  1683 */ "Clients" "\0"
  /*  1691 */ "Clipboard" "\0"
  /*  1701 */ "ClipboardEvent" "\0"
  /*  1716 */ "ClipboardItem" "\0"
  /*  1730 */ "ClonedErrorHolder" "\0"
  /*  1748 */ "CloseEvent" "\0"
  /*  1759 */ "CommandEvent" "\0"
  /*  1772 */ "Comment" "\0"
  /*  1780 */ "CompositionEvent" "\0"
  /*  1797 */ "CompressionStream" "\0"
  /*  1815 */ "ConsoleInstance" "\0"
  /*  1831 */ "ConstantSourceNode" "\0"
  /*  1850 */ "ContentFrameMessageManager" "\0"
  /*  1877 */ "ContentProcessMessageManager" "\0"
  /*  1906 */ "ContentVisibilityAutoStateChangeEvent" "\0"
  /*  1944 */ "ConvolverNode" "\0"
  /*  1958 */ "CountQueuingStrategy" "\0"
  /*  1979 */ "CreateOfferRequest" "\0"
  /*  1998 */ "Credential" "\0"
  /*  2009 */ "CredentialsContainer" "\0"
  /*  2030 */ "Crypto" "\0"
  /*  2037 */ "CryptoKey" "\0"
  /*  2047 */ "CustomElementRegistry" "\0"
  /*  2069 */ "CustomEvent" "\0"
  /*  2081 */ "DOMException" "\0"
  /*  2094 */ "DOMImplementation" "\0"
  /*  2112 */ "DOMLocalization" "\0"
  /*  2128 */ "DOMMatrix" "\0"
  /*  2138 */ "DOMMatrixReadOnly" "\0"
  /*  2156 */ "DOMParser" "\0"
  /*  2166 */ "DOMPoint" "\0"
  /*  2175 */ "DOMPointReadOnly" "\0"
  /*  2192 */ "DOMQuad" "\0"
  /*  2200 */ "DOMRect" "\0"
  /*  2208 */ "DOMRectList" "\0"
  /*  2220 */ "DOMRectReadOnly" "\0"
  /*  2236 */ "DOMRequest" "\0"
  /*  2247 */ "DOMStringList" "\0"
  /*  2261 */ "DOMStringMap" "\0"
  /*  2274 */ "DOMTokenList" "\0"
  /*  2287 */ "DataTransfer" "\0"
  /*  2300 */ "DataTransferItem" "\0"
  /*  2317 */ "DataTransferItemList" "\0"
  /*  2338 */ "DebuggerNotification" "\0"
  /*  2359 */ "DebuggerNotificationObserver" "\0"
  /*  2388 */ "DecompressionStream" "\0"
  /*  2408 */ "DedicatedWorkerGlobalScope" "\0"
  /*  2435 */ "DelayNode" "\0"
  /*  2445 */ "DeprecationReportBody" "\0"
  /*  2467 */ "DeviceAcceleration" "\0"
  /*  2486 */ "DeviceLightEvent" "\0"
  /*  2503 */ "DeviceMotionEvent" "\0"
  /*  2521 */ "DeviceOrientationEvent" "\0"
  /*  2544 */ "DeviceRotationRate" "\0"
  /*  2563 */ "Directory" "\0"
  /*  2573 */ "Document" "\0"
  /*  2582 */ "DocumentFragment" "\0"
  /*  2599 */ "DocumentL10n" "\0"
  /*  2612 */ "DocumentTimeline" "\0"
  /*  2629 */ "DocumentType" "\0"
  /*  2642 */ "DominatorTree" "\0"
  /*  2656 */ "DragEvent" "\0"
  /*  2666 */ "DynamicsCompressorNode" "\0"
  /*  2689 */ "EXT_blend_minmax" "\0"
  /*  2706 */ "EXT_color_buffer_float" "\0"
  /*  2729 */ "EXT_color_buffer_half_float" "\0"
  /*  2757 */ "EXT_disjoint_timer_query" "\0"
  /*  2782 */ "EXT_float_blend" "\0"
  /*  2798 */ "EXT_frag_depth" "\0"
  /*  2813 */ "EXT_sRGB" "\0"
  /*  2822 */ "EXT_shader_texture_lod" "\0"
  /*  2845 */ "EXT_texture_compression_bptc" "\0"
  /*  2874 */ "EXT_texture_compression_rgtc" "\0"
  /*  2903 */ "EXT_texture_filter_anisotropic" "\0"
  /*  2934 */ "EXT_texture_norm16" "\0"
  /*  2953 */ "Element" "\0"
  /*  2961 */ "ElementInternals" "\0"
  /*  2978 */ "EncodedVideoChunk" "\0"
  /*  2996 */ "ErrorEvent" "\0"
  /*  3007 */ "Event" "\0"
  /*  3013 */ "EventCallbackDebuggerNotification" "\0"
  /*  3047 */ "EventCounts" "\0"
  /*  3059 */ "EventSource" "\0"
  /*  3071 */ "EventTarget" "\0"
  /*  3083 */ "Exception" "\0"
  /*  3093 */ "ExtendableEvent" "\0"
  /*  3109 */ "ExtendableMessageEvent" "\0"
  /*  3132 */ "ExtensionAlarms" "\0"
  /*  3148 */ "ExtensionBrowser" "\0"
  /*  3165 */ "ExtensionBrowserSettings" "\0"
  /*  3190 */ "ExtensionBrowserSettingsColorManagement" "\0"
  /*  3230 */ "ExtensionDns" "\0"
  /*  3243 */ "ExtensionEventManager" "\0"
  /*  3265 */ "ExtensionMockAPI" "\0"
  /*  3282 */ "ExtensionPort" "\0"
  /*  3296 */ "ExtensionProxy" "\0"
  /*  3311 */ "ExtensionRuntime" "\0"
  /*  3328 */ "ExtensionScripting" "\0"
  /*  3347 */ "ExtensionSetting" "\0"
  /*  3364 */ "ExtensionTest" "\0"
  /*  3378 */ "External" "\0"
  /*  3387 */ "FeaturePolicy" "\0"
  /*  3401 */ "FeaturePolicyViolationReportBody" "\0"
  /*  3434 */ "FetchEvent" "\0"
  /*  3445 */ "FetchObserver" "\0"
  /*  3459 */ "File" "\0"
  /*  3464 */ "FileList" "\0"
  /*  3473 */ "FileReader" "\0"
  /*  3484 */ "FileReaderSync" "\0"
  /*  3499 */ "FileSystem" "\0"
  /*  3510 */ "FileSystemDirectoryEntry" "\0"
  /*  3535 */ "FileSystemDirectoryHandle" "\0"
  /*  3561 */ "FileSystemDirectoryHandle AsyncIterator" "\0"
  /*  3601 */ "FileSystemDirectoryIterator" "\0"
  /*  3629 */ "FileSystemDirectoryReader" "\0"
  /*  3655 */ "FileSystemEntry" "\0"
  /*  3671 */ "FileSystemFileEntry" "\0"
  /*  3691 */ "FileSystemFileHandle" "\0"
  /*  3712 */ "FileSystemHandle" "\0"
  /*  3729 */ "FileSystemSyncAccessHandle" "\0"
  /*  3756 */ "FileSystemWritableFileStream" "\0"
  /*  3785 */ "Flex" "\0"
  /*  3790 */ "FlexItemValues" "\0"
  /*  3805 */ "FlexLineValues" "\0"
  /*  3820 */ "FluentBundle" "\0"
  /*  3833 */ "FluentBundleAsyncIterator" "\0"
  /*  3859 */ "FluentBundleIterator" "\0"
  /*  3880 */ "FluentPattern" "\0"
  /*  3894 */ "FluentResource" "\0"
  /*  3909 */ "FocusEvent" "\0"
  /*  3920 */ "FontFace" "\0"
  /*  3929 */ "FontFaceSet" "\0"
  /*  3941 */ "FontFaceSetIterator" "\0"
  /*  3961 */ "FontFaceSetLoadEvent" "\0"
  /*  3982 */ "FormData" "\0"
  /*  3991 */ "FormData Iterator" "\0"
  /*  4009 */ "FormDataEvent" "\0"
  /*  4023 */ "FrameCrashedEvent" "\0"
  /*  4041 */ "FrameLoader" "\0"
  /*  4053 */ "GPU" "\0"
  /*  4057 */ "GPUAdapter" "\0"
  /*  4068 */ "GPUAdapterInfo" "\0"
  /*  4083 */ "GPUBindGroup" "\0"
  /*  4096 */ "GPUBindGroupLayout" "\0"
  /*  4115 */ "GPUBuffer" "\0"
  /*  4125 */ "GPUBufferUsage" "\0"
  /*  4140 */ "GPUCanvasContext" "\0"
  /*  4157 */ "GPUColorWrite" "\0"
  /*  4171 */ "GPUCommandBuffer" "\0"
  /*  4188 */ "GPUCommandEncoder" "\0"
  /*  4206 */ "GPUCompilationInfo" "\0"
  /*  4225 */ "GPUCompilationMessage" "\0"
  /*  4247 */ "GPUComputePassEncoder" "\0"
  /*  4269 */ "GPUComputePipeline" "\0"
  /*  4288 */ "GPUDevice" "\0"
  /*  4298 */ "GPUDeviceLostInfo" "\0"
  /*  4316 */ "GPUError" "\0"
  /*  4325 */ "GPUInternalError" "\0"
  /*  4342 */ "GPUMapMode" "\0"
  /*  4353 */ "GPUOutOfMemoryError" "\0"
  /*  4373 */ "GPUPipelineLayout" "\0"
  /*  4391 */ "GPUQuerySet" "\0"
  /*  4403 */ "GPUQueue" "\0"
  /*  4412 */ "GPURenderBundle" "\0"
  /*  4428 */ "GPURenderBundleEncoder" "\0"
  /*  4451 */ "GPURenderPassEncoder" "\0"
  /*  4472 */ "GPURenderPipeline" "\0"
  /*  4490 */ "GPUSampler" "\0"
  /*  4501 */ "GPUShaderModule" "\0"
  /*  4517 */ "GPUShaderStage" "\0"
  /*  4532 */ "GPUSupportedFeatures" "\0"
  /*  4553 */ "GPUSupportedLimits" "\0"
  /*  4572 */ "GPUTexture" "\0"
  /*  4583 */ "GPUTextureUsage" "\0"
  /*  4599 */ "GPUTextureView" "\0"
  /*  4614 */ "GPUUncapturedErrorEvent" "\0"
  /*  4638 */ "GPUValidationError" "\0"
  /*  4657 */ "GainNode" "\0"
  /*  4666 */ "Gamepad" "\0"
  /*  4674 */ "GamepadAxisMoveEvent" "\0"
  /*  4695 */ "GamepadButton" "\0"
  /*  4709 */ "GamepadButtonEvent" "\0"
  /*  4728 */ "GamepadEvent" "\0"
  /*  4741 */ "GamepadHapticActuator" "\0"
  /*  4763 */ "GamepadLightIndicator" "\0"
  /*  4785 */ "GamepadPose" "\0"
  /*  4797 */ "GamepadServiceTest" "\0"
  /*  4816 */ "GamepadTouch" "\0"
  /*  4829 */ "Geolocation" "\0"
  /*  4841 */ "GeolocationCoordinates" "\0"
  /*  4864 */ "GeolocationPosition" "\0"
  /*  4884 */ "GeolocationPositionError" "\0"
  /*  4909 */ "GetUserMediaRequest" "\0"
  /*  4929 */ "GleanCategory" "\0"
  /*  4943 */ "GleanImpl" "\0"
  /*  4953 */ "GleanLabeled" "\0"
  /*  4966 */ "GleanPingsImpl" "\0"
  /*  4981 */ "Grid" "\0"
  /*  4986 */ "GridArea" "\0"
  /*  4995 */ "GridDimension" "\0"
  /*  5009 */ "GridLine" "\0"
  /*  5018 */ "GridLines" "\0"
  /*  5028 */ "GridTrack" "\0"
  /*  5038 */ "GridTracks" "\0"
  /*  5049 */ "HTMLAllCollection" "\0"
  /*  5067 */ "HTMLAnchorElement" "\0"
  /*  5085 */ "HTMLAreaElement" "\0"
  /*  5101 */ "HTMLAudioElement" "\0"
  /*  5118 */ "HTMLBRElement" "\0"
  /*  5132 */ "HTMLBaseElement" "\0"
  /*  5148 */ "HTMLBodyElement" "\0"
  /*  5164 */ "HTMLButtonElement" "\0"
  /*  5182 */ "HTMLCanvasElement" "\0"
  /*  5200 */ "HTMLCollection" "\0"
  /*  5215 */ "HTMLDListElement" "\0"
  /*  5232 */ "HTMLDataElement" "\0"
  /*  5248 */ "HTMLDataListElement" "\0"
  /*  5268 */ "HTMLDetailsElement" "\0"
  /*  5287 */ "HTMLDialogElement" "\0"
  /*  5305 */ "HTMLDirectoryElement" "\0"
  /*  5326 */ "HTMLDivElement" "\0"
  /*  5341 */ "HTMLDocument" "\0"
  /*  5354 */ "HTMLElement" "\0"
  /*  5366 */ "HTMLEmbedElement" "\0"
  /*  5383 */ "HTMLFieldSetElement" "\0"
  /*  5403 */ "HTMLFontElement" "\0"
  /*  5419 */ "HTMLFormControlsCollection" "\0"
  /*  5446 */ "HTMLFormElement" "\0"
  /*  5462 */ "HTMLFrameElement" "\0"
  /*  5479 */ "HTMLFrameSetElement" "\0"
  /*  5499 */ "HTMLHRElement" "\0"
  /*  5513 */ "HTMLHeadElement" "\0"
  /*  5529 */ "HTMLHeadingElement" "\0"
  /*  5548 */ "HTMLHtmlElement" "\0"
  /*  5564 */ "HTMLIFrameElement" "\0"
  /*  5582 */ "HTMLImageElement" "\0"
  /*  5599 */ "HTMLInputElement" "\0"
  /*  5616 */ "HTMLLIElement" "\0"
  /*  5630 */ "HTMLLabelElement" "\0"
  /*  5647 */ "HTMLLegendElement" "\0"
  /*  5665 */ "HTMLLinkElement" "\0"
  /*  5681 */ "HTMLMapElement" "\0"
  /*  5696 */ "HTMLMarqueeElement" "\0"
  /*  5715 */ "HTMLMediaElement" "\0"
  /*  5732 */ "HTMLMenuElement" "\0"
  /*  5748 */ "HTMLMetaElement" "\0"
  /*  5764 */ "HTMLMeterElement" "\0"
  /*  5781 */ "HTMLModElement" "\0"
  /*  5796 */ "HTMLOListElement" "\0"
  /*  5813 */ "HTMLObjectElement" "\0"
  /*  5831 */ "HTMLOptGroupElement" "\0"
  /*  5851 */ "HTMLOptionElement" "\0"
  /*  5869 */ "HTMLOptionsCollection" "\0"
  /*  5891 */ "HTMLOutputElement" "\0"
  /*  5909 */ "HTMLParagraphElement" "\0"
  /*  5930 */ "HTMLParamElement" "\0"
  /*  5947 */ "HTMLPictureElement" "\0"
  /*  5966 */ "HTMLPreElement" "\0"
  /*  5981 */ "HTMLProgressElement" "\0"
  /*  6001 */ "HTMLQuoteElement" "\0"
  /*  6018 */ "HTMLScriptElement" "\0"
  /*  6036 */ "HTMLSelectElement" "\0"
  /*  6054 */ "HTMLSlotElement" "\0"
  /*  6070 */ "HTMLSourceElement" "\0"
  /*  6088 */ "HTMLSpanElement" "\0"
  /*  6104 */ "HTMLStyleElement" "\0"
  /*  6121 */ "HTMLTableCaptionElement" "\0"
  /*  6145 */ "HTMLTableCellElement" "\0"
  /*  6166 */ "HTMLTableColElement" "\0"
  /*  6186 */ "HTMLTableElement" "\0"
  /*  6203 */ "HTMLTableRowElement" "\0"
  /*  6223 */ "HTMLTableSectionElement" "\0"
  /*  6247 */ "HTMLTemplateElement" "\0"
  /*  6267 */ "HTMLTextAreaElement" "\0"
  /*  6287 */ "HTMLTimeElement" "\0"
  /*  6303 */ "HTMLTitleElement" "\0"
  /*  6320 */ "HTMLTrackElement" "\0"
  /*  6337 */ "HTMLUListElement" "\0"
  /*  6354 */ "HTMLUnknownElement" "\0"
  /*  6373 */ "HTMLVideoElement" "\0"
  /*  6390 */ "HashChangeEvent" "\0"
  /*  6406 */ "Headers" "\0"
  /*  6414 */ "Headers Iterator" "\0"
  /*  6431 */ "HeapSnapshot" "\0"
  /*  6444 */ "Highlight" "\0"
  /*  6454 */ "HighlightRegistry" "\0"
  /*  6472 */ "History" "\0"
  /*  6480 */ "IDBCursor" "\0"
  /*  6490 */ "IDBCursorWithValue" "\0"
  /*  6509 */ "IDBDatabase" "\0"
  /*  6521 */ "IDBFactory" "\0"
  /*  6532 */ "IDBIndex" "\0"
  /*  6541 */ "IDBKeyRange" "\0"
  /*  6553 */ "IDBLocaleAwareKeyRange" "\0"
  /*  6576 */ "IDBObjectStore" "\0"
  /*  6591 */ "IDBOpenDBRequest" "\0"
  /*  6608 */ "IDBRequest" "\0"
  /*  6619 */ "IDBTransaction" "\0"
  /*  6634 */ "IDBVersionChangeEvent" "\0"
  /*  6656 */ "IIRFilterNode" "\0"
  /*  6670 */ "IOUtils" "\0"
  /*  6678 */ "IdentityCredential" "\0"
  /*  6697 */ "IdleDeadline" "\0"
  /*  6710 */ "Image" "\0"
  /*  6716 */ "ImageBitmap" "\0"
  /*  6728 */ "ImageBitmapRenderingContext" "\0"
  /*  6756 */ "ImageCapture" "\0"
  /*  6769 */ "ImageCaptureError" "\0"
  /*  6787 */ "ImageCaptureErrorEvent" "\0"
  /*  6810 */ "ImageData" "\0"
  /*  6820 */ "ImageDocument" "\0"
  /*  6834 */ "InputEvent" "\0"
  /*  6845 */ "InspectorFontFace" "\0"
  /*  6863 */ "InspectorUtils" "\0"
  /*  6878 */ "InstallTriggerImpl" "\0"
  /*  6897 */ "IntersectionObserver" "\0"
  /*  6918 */ "IntersectionObserverEntry" "\0"
  /*  6944 */ "IntlUtils" "\0"
  /*  6954 */ "JSProcessActorChild" "\0"
  /*  6974 */ "JSProcessActorParent" "\0"
  /*  6995 */ "JSWindowActorChild" "\0"
  /*  7014 */ "JSWindowActorParent" "\0"
  /*  7034 */ "KeyEvent" "\0"
  /*  7043 */ "KeyboardEvent" "\0"
  /*  7057 */ "KeyframeEffect" "\0"
  /*  7072 */ "L10nFileSource" "\0"
  /*  7087 */ "L10nOverlays" "\0"
  /*  7100 */ "L10nRegistry" "\0"
  /*  7113 */ "LargestContentfulPaint" "\0"
  /*  7136 */ "LegacyMozTCPSocket" "\0"
  /*  7155 */ "Localization" "\0"
  /*  7168 */ "Location" "\0"
  /*  7177 */ "Lock" "\0"
  /*  7182 */ "LockManager" "\0"
  /*  7194 */ "MIDIAccess" "\0"
  /*  7205 */ "MIDIConnectionEvent" "\0"
  /*  7225 */ "MIDIInput" "\0"
  /*  7235 */ "MIDIInputMap" "\0"
  /*  7248 */ "MIDIMessageEvent" "\0"
  /*  7265 */ "MIDIOutput" "\0"
  /*  7276 */ "MIDIOutputMap" "\0"
  /*  7290 */ "MIDIPort" "\0"
  /*  7299 */ "MOZ_debug" "\0"
  /*  7309 */ "MatchGlob" "\0"
  /*  7319 */ "MatchPattern" "\0"
  /*  7332 */ "MatchPatternSet" "\0"
  /*  7348 */ "MathMLElement" "\0"
  /*  7362 */ "MediaCapabilities" "\0"
  /*  7380 */ "MediaCapabilitiesInfo" "\0"
  /*  7402 */ "MediaControlService" "\0"
  /*  7422 */ "MediaController" "\0"
  /*  7438 */ "MediaDeviceInfo" "\0"
  /*  7454 */ "MediaDevices" "\0"
  /*  7467 */ "MediaElementAudioSourceNode" "\0"
  /*  7495 */ "MediaEncryptedEvent" "\0"
  /*  7515 */ "MediaError" "\0"
  /*  7526 */ "MediaKeyError" "\0"
  /*  7540 */ "MediaKeyMessageEvent" "\0"
  /*  7561 */ "MediaKeySession" "\0"
  /*  7577 */ "MediaKeyStatusMap" "\0"
  /*  7595 */ "MediaKeyStatusMap Iterator" "\0"
  /*  7622 */ "MediaKeySystemAccess" "\0"
  /*  7643 */ "MediaKeys" "\0"
  /*  7653 */ "MediaList" "\0"
  /*  7663 */ "MediaMetadata" "\0"
  /*  7677 */ "MediaQueryList" "\0"
  /*  7692 */ "MediaQueryListEvent" "\0"
  /*  7712 */ "MediaRecorder" "\0"
  /*  7726 */ "MediaRecorderErrorEvent" "\0"
  /*  7750 */ "MediaSession" "\0"
  /*  7763 */ "MediaSource" "\0"
  /*  7775 */ "MediaStream" "\0"
  /*  7787 */ "MediaStreamAudioDestinationNode" "\0"
  /*  7819 */ "MediaStreamAudioSourceNode" "\0"
  /*  7846 */ "MediaStreamError" "\0"
  /*  7863 */ "MediaStreamEvent" "\0"
  /*  7880 */ "MediaStreamTrack" "\0"
  /*  7897 */ "MediaStreamTrackAudioSourceNode" "\0"
  /*  7929 */ "MediaStreamTrackEvent" "\0"
  /*  7951 */ "MerchantValidationEvent" "\0"
  /*  7975 */ "MessageBroadcaster" "\0"
  /*  7994 */ "MessageChannel" "\0"
  /*  8009 */ "MessageEvent" "\0"
  /*  8022 */ "MessageListenerManager" "\0"
  /*  8045 */ "MessagePort" "\0"
  /*  8057 */ "MessageSender" "\0"
  /*  8071 */ "MimeType" "\0"
  /*  8080 */ "MimeTypeArray" "\0"
  /*  8094 */ "MouseEvent" "\0"
  /*  8105 */ "MouseScrollEvent" "\0"
  /*  8122 */ "MozCanvasPrintState" "\0"
  /*  8142 */ "MozDocumentMatcher" "\0"
  /*  8161 */ "MozDocumentObserver" "\0"
  /*  8181 */ "MozQueryInterface" "\0"
  /*  8199 */ "MozSharedMap" "\0"
  /*  8212 */ "MozSharedMap Iterator" "\0"
  /*  8234 */ "MozSharedMapChangeEvent" "\0"
  /*  8258 */ "MozStorageAsyncStatementParams" "\0"
  /*  8289 */ "MozStorageStatementParams" "\0"
  /*  8315 */ "MozStorageStatementRow" "\0"
  /*  8338 */ "MozWritableSharedMap" "\0"
  /*  8359 */ "MutationEvent" "\0"
  /*  8373 */ "MutationObserver" "\0"
  /*  8390 */ "MutationRecord" "\0"
  /*  8405 */ "NamedNodeMap" "\0"
  /*  8418 */ "NavigationPreloadManager" "\0"
  /*  8443 */ "Navigator" "\0"
  /*  8453 */ "NetworkInformation" "\0"
  /*  8472 */ "Node" "\0"
  /*  8477 */ "NodeFilter" "\0"
  /*  8488 */ "NodeIterator" "\0"
  /*  8501 */ "NodeList" "\0"
  /*  8510 */ "Notification" "\0"
  /*  8523 */ "NotificationEvent" "\0"
  /*  8541 */ "NotifyPaintEvent" "\0"
  /*  8558 */ "OES_draw_buffers_indexed" "\0"
  /*  8583 */ "OES_element_index_uint" "\0"
  /*  8606 */ "OES_fbo_render_mipmap" "\0"
  /*  8628 */ "OES_standard_derivatives" "\0"
  /*  8653 */ "OES_texture_float" "\0"
  /*  8671 */ "OES_texture_float_linear" "\0"
  /*  8696 */ "OES_texture_half_float" "\0"
  /*  8719 */ "OES_texture_half_float_linear" "\0"
  /*  8749 */ "OES_vertex_array_object" "\0"
  /*  8773 */ "OVR_multiview2" "\0"
  /*  8788 */ "OfflineAudioCompletionEvent" "\0"
  /*  8816 */ "OfflineAudioContext" "\0"
  /*  8836 */ "OffscreenCanvas" "\0"
  /*  8852 */ "OffscreenCanvasRenderingContext2D" "\0"
  /*  8886 */ "OnlyForUseInConstructor" "\0"
  /*  8910 */ "Option" "\0"
  /*  8917 */ "OscillatorNode" "\0"
  /*  8932 */ "PageTransitionEvent" "\0"
  /*  8952 */ "PaintRequest" "\0"
  /*  8965 */ "PaintRequestList" "\0"
  /*  8982 */ "PaintWorkletGlobalScope" "\0"
  /*  9006 */ "PannerNode" "\0"
  /*  9017 */ "ParentProcessMessageManager" "\0"
  /*  9045 */ "Path2D" "\0"
  /*  9052 */ "PathUtils" "\0"
  /*  9062 */ "PaymentAddress" "\0"
  /*  9077 */ "PaymentMethodChangeEvent" "\0"
  /*  9102 */ "PaymentRequest" "\0"
  /*  9117 */ "PaymentRequestUpdateEvent" "\0"
  /*  9143 */ "PaymentResponse" "\0"
  /*  9159 */ "PeerConnectionImpl" "\0"
  /*  9178 */ "PeerConnectionObserver" "\0"
  /*  9201 */ "Performance" "\0"
  /*  9213 */ "PerformanceEntry" "\0"
  /*  9230 */ "PerformanceEntryEvent" "\0"
  /*  9252 */ "PerformanceEventTiming" "\0"
  /*  9275 */ "PerformanceMark" "\0"
  /*  9291 */ "PerformanceMeasure" "\0"
  /*  9310 */ "PerformanceNavigation" "\0"
  /*  9332 */ "PerformanceNavigationTiming" "\0"
  /*  9360 */ "PerformanceObserver" "\0"
  /*  9380 */ "PerformanceObserverEntryList" "\0"
  /*  9409 */ "PerformancePaintTiming" "\0"
  /*  9432 */ "PerformanceResourceTiming" "\0"
  /*  9458 */ "PerformanceServerTiming" "\0"
  /*  9482 */ "PerformanceTiming" "\0"
  /*  9500 */ "PeriodicWave" "\0"
  /*  9513 */ "PermissionStatus" "\0"
  /*  9530 */ "Permissions" "\0"
  /*  9542 */ "PlacesBookmark" "\0"
  /*  9557 */ "PlacesBookmarkAddition" "\0"
  /*  9580 */ "PlacesBookmarkChanged" "\0"
  /*  9602 */ "PlacesBookmarkGuid" "\0"
  /*  9621 */ "PlacesBookmarkKeyword" "\0"
  /*  9643 */ "PlacesBookmarkMoved" "\0"
  /*  9663 */ "PlacesBookmarkRemoved" "\0"
  /*  9685 */ "PlacesBookmarkTags" "\0"
  /*  9704 */ "PlacesBookmarkTime" "\0"
  /*  9723 */ "PlacesBookmarkTitle" "\0"
  /*  9743 */ "PlacesBookmarkUrl" "\0"
  /*  9761 */ "PlacesEvent" "\0"
  /*  9773 */ "PlacesFavicon" "\0"
  /*  9787 */ "PlacesHistoryCleared" "\0"
  /*  9808 */ "PlacesObservers" "\0"
  /*  9824 */ "PlacesPurgeCaches" "\0"
  /*  9842 */ "PlacesRanking" "\0"
  /*  9856 */ "PlacesVisit" "\0"
  /*  9868 */ "PlacesVisitRemoved" "\0"
  /*  9887 */ "PlacesVisitTitle" "\0"
  /*  9904 */ "PlacesWeakCallbackWrapper" "\0"
  /*  9930 */ "Plugin" "\0"
  /*  9937 */ "PluginArray" "\0"
  /*  9949 */ "PluginCrashedEvent" "\0"
  /*  9968 */ "PointerEvent" "\0"
  /*  9981 */ "PopStateEvent" "\0"
  /*  9995 */ "PopupBlockedEvent" "\0"
  /* 10013 */ "PopupPositionedEvent" "\0"
  /* 10034 */ "PositionStateEvent" "\0"
  /* 10053 */ "PrecompiledScript" "\0"
  /* 10071 */ "ProcessMessageManager" "\0"
  /* 10093 */ "ProcessingInstruction" "\0"
  /* 10115 */ "ProgressEvent" "\0"
  /* 10129 */ "PromiseDebugging" "\0"
  /* 10146 */ "PromiseNativeHandler" "\0"
  /* 10167 */ "PromiseRejectionEvent" "\0"
  /* 10189 */ "PublicKeyCredential" "\0"
  /* 10209 */ "PushEvent" "\0"
  /* 10219 */ "PushManager" "\0"
  /* 10231 */ "PushManagerImpl" "\0"
  /* 10247 */ "PushMessageData" "\0"
  /* 10263 */ "PushSubscription" "\0"
  /* 10280 */ "PushSubscriptionOptions" "\0"
  /* 10304 */ "RTCCertificate" "\0"
  /* 10319 */ "RTCDTMFSender" "\0"
  /* 10333 */ "RTCDTMFToneChangeEvent" "\0"
  /* 10356 */ "RTCDataChannel" "\0"
  /* 10371 */ "RTCDataChannelEvent" "\0"
  /* 10391 */ "RTCDtlsTransport" "\0"
  /* 10408 */ "RTCEncodedAudioFrame" "\0"
  /* 10429 */ "RTCEncodedVideoFrame" "\0"
  /* 10450 */ "RTCIceCandidate" "\0"
  /* 10466 */ "RTCIdentityProviderRegistrar" "\0"
  /* 10495 */ "RTCPeerConnection" "\0"
  /* 10513 */ "RTCPeerConnectionIceEvent" "\0"
  /* 10539 */ "RTCPeerConnectionStatic" "\0"
  /* 10563 */ "RTCRtpReceiver" "\0"
  /* 10578 */ "RTCRtpScriptTransform" "\0"
  /* 10600 */ "RTCRtpScriptTransformer" "\0"
  /* 10624 */ "RTCRtpSender" "\0"
  /* 10637 */ "RTCRtpTransceiver" "\0"
  /* 10655 */ "RTCSctpTransport" "\0"
  /* 10672 */ "RTCSessionDescription" "\0"
  /* 10694 */ "RTCStatsReport" "\0"
  /* 10709 */ "RTCTrackEvent" "\0"
  /* 10723 */ "RTCTransformEvent" "\0"
  /* 10741 */ "RadioNodeList" "\0"
  /* 10755 */ "Range" "\0"
  /* 10761 */ "ReadableByteStreamController" "\0"
  /* 10790 */ "ReadableStream" "\0"
  /* 10805 */ "ReadableStream AsyncIterator" "\0"
  /* 10834 */ "ReadableStreamBYOBReader" "\0"
  /* 10859 */ "ReadableStreamBYOBRequest" "\0"
  /* 10885 */ "ReadableStreamDefaultController" "\0"
  /* 10917 */ "ReadableStreamDefaultReader" "\0"
  /* 10945 */ "Report" "\0"
  /* 10952 */ "ReportBody" "\0"
  /* 10963 */ "ReportingObserver" "\0"
  /* 10981 */ "Request" "\0"
  /* 10989 */ "ResizeObserver" "\0"
  /* 11004 */ "ResizeObserverEntry" "\0"
  /* 11024 */ "ResizeObserverSize" "\0"
  /* 11043 */ "Response" "\0"
  /* 11052 */ "SVGAElement" "\0"
  /* 11064 */ "SVGAngle" "\0"
  /* 11073 */ "SVGAnimateElement" "\0"
  /* 11091 */ "SVGAnimateMotionElement" "\0"
  /* 11115 */ "SVGAnimateTransformElement" "\0"
  /* 11142 */ "SVGAnimatedAngle" "\0"
  /* 11159 */ "SVGAnimatedBoolean" "\0"
  /* 11178 */ "SVGAnimatedEnumeration" "\0"
  /* 11201 */ "SVGAnimatedInteger" "\0"
  /* 11220 */ "SVGAnimatedLength" "\0"
  /* 11238 */ "SVGAnimatedLengthList" "\0"
  /* 11260 */ "SVGAnimatedNumber" "\0"
  /* 11278 */ "SVGAnimatedNumberList" "\0"
  /* 11300 */ "SVGAnimatedPreserveAspectRatio" "\0"
  /* 11331 */ "SVGAnimatedRect" "\0"
  /* 11347 */ "SVGAnimatedString" "\0"
  /* 11365 */ "SVGAnimatedTransformList" "\0"
  /* 11390 */ "SVGAnimationElement" "\0"
  /* 11410 */ "SVGCircleElement" "\0"
  /* 11427 */ "SVGClipPathElement" "\0"
  /* 11446 */ "SVGComponentTransferFunctionElement" "\0"
  /* 11482 */ "SVGDefsElement" "\0"
  /* 11497 */ "SVGDescElement" "\0"
  /* 11512 */ "SVGElement" "\0"
  /* 11523 */ "SVGEllipseElement" "\0"
  /* 11541 */ "SVGFEBlendElement" "\0"
  /* 11559 */ "SVGFEColorMatrixElement" "\0"
  /* 11583 */ "SVGFEComponentTransferElement" "\0"
  /* 11613 */ "SVGFECompositeElement" "\0"
  /* 11635 */ "SVGFEConvolveMatrixElement" "\0"
  /* 11662 */ "SVGFEDiffuseLightingElement" "\0"
  /* 11690 */ "SVGFEDisplacementMapElement" "\0"
  /* 11718 */ "SVGFEDistantLightElement" "\0"
  /* 11743 */ "SVGFEDropShadowElement" "\0"
  /* 11766 */ "SVGFEFloodElement" "\0"
  /* 11784 */ "SVGFEFuncAElement" "\0"
  /* 11802 */ "SVGFEFuncBElement" "\0"
  /* 11820 */ "SVGFEFuncGElement" "\0"
  /* 11838 */ "SVGFEFuncRElement" "\0"
  /* 11856 */ "SVGFEGaussianBlurElement" "\0"
  /* 11881 */ "SVGFEImageElement" "\0"
  /* 11899 */ "SVGFEMergeElement" "\0"
  /* 11917 */ "SVGFEMergeNodeElement" "\0"
  /* 11939 */ "SVGFEMorphologyElement" "\0"
  /* 11962 */ "SVGFEOffsetElement" "\0"
  /* 11981 */ "SVGFEPointLightElement" "\0"
  /* 12004 */ "SVGFESpecularLightingElement" "\0"
  /* 12033 */ "SVGFESpotLightElement" "\0"
  /* 12055 */ "SVGFETileElement" "\0"
  /* 12072 */ "SVGFETurbulenceElement" "\0"
  /* 12095 */ "SVGFilterElement" "\0"
  /* 12112 */ "SVGForeignObjectElement" "\0"
  /* 12136 */ "SVGGElement" "\0"
  /* 12148 */ "SVGGeometryElement" "\0"
  /* 12167 */ "SVGGradientElement" "\0"
  /* 12186 */ "SVGGraphicsElement" "\0"
  /* 12205 */ "SVGImageElement" "\0"
  /* 12221 */ "SVGLength" "\0"
  /* 12231 */ "SVGLengthList" "\0"
  /* 12245 */ "SVGLineElement" "\0"
  /* 12260 */ "SVGLinearGradientElement" "\0"
  /* 12285 */ "SVGMPathElement" "\0"
  /* 12301 */ "SVGMarkerElement" "\0"
  /* 12318 */ "SVGMaskElement" "\0"
  /* 12333 */ "SVGMatrix" "\0"
  /* 12343 */ "SVGMetadataElement" "\0"
  /* 12362 */ "SVGNumber" "\0"
  /* 12372 */ "SVGNumberList" "\0"
  /* 12386 */ "SVGPathElement" "\0"
  /* 12401 */ "SVGPathSeg" "\0"
  /* 12412 */ "SVGPathSegArcAbs" "\0"
  /* 12429 */ "SVGPathSegArcRel" "\0"
  /* 12446 */ "SVGPathSegClosePath" "\0"
  /* 12466 */ "SVGPathSegCurvetoCubicAbs" "\0"
  /* 12492 */ "SVGPathSegCurvetoCubicRel" "\0"
  /* 12518 */ "SVGPathSegCurvetoCubicSmoothAbs" "\0"
  /* 12550 */ "SVGPathSegCurvetoCubicSmoothRel" "\0"
  /* 12582 */ "SVGPathSegCurvetoQuadraticAbs" "\0"
  /* 12612 */ "SVGPathSegCurvetoQuadraticRel" "\0"
  /* 12642 */ "SVGPathSegCurvetoQuadraticSmoothAbs" "\0"
  /* 12678 */ "SVGPathSegCurvetoQuadraticSmoothRel" "\0"
  /* 12714 */ "SVGPathSegLinetoAbs" "\0"
  /* 12734 */ "SVGPathSegLinetoHorizontalAbs" "\0"
  /* 12764 */ "SVGPathSegLinetoHorizontalRel" "\0"
  /* 12794 */ "SVGPathSegLinetoRel" "\0"
  /* 12814 */ "SVGPathSegLinetoVerticalAbs" "\0"
  /* 12842 */ "SVGPathSegLinetoVerticalRel" "\0"
  /* 12870 */ "SVGPathSegList" "\0"
  /* 12885 */ "SVGPathSegMovetoAbs" "\0"
  /* 12905 */ "SVGPathSegMovetoRel" "\0"
  /* 12925 */ "SVGPatternElement" "\0"
  /* 12943 */ "SVGPoint" "\0"
  /* 12952 */ "SVGPointList" "\0"
  /* 12965 */ "SVGPolygonElement" "\0"
  /* 12983 */ "SVGPolylineElement" "\0"
  /* 13002 */ "SVGPreserveAspectRatio" "\0"
  /* 13025 */ "SVGRadialGradientElement" "\0"
  /* 13050 */ "SVGRect" "\0"
  /* 13058 */ "SVGRectElement" "\0"
  /* 13073 */ "SVGSVGElement" "\0"
  /* 13087 */ "SVGScriptElement" "\0"
  /* 13104 */ "SVGSetElement" "\0"
  /* 13118 */ "SVGStopElement" "\0"
  /* 13133 */ "SVGStringList" "\0"
  /* 13147 */ "SVGStyleElement" "\0"
  /* 13163 */ "SVGSwitchElement" "\0"
  /* 13180 */ "SVGSymbolElement" "\0"
  /* 13197 */ "SVGTSpanElement" "\0"
  /* 13213 */ "SVGTextContentElement" "\0"
  /* 13235 */ "SVGTextElement" "\0"
  /* 13250 */ "SVGTextPathElement" "\0"
  /* 13269 */ "SVGTextPositioningElement" "\0"
  /* 13295 */ "SVGTitleElement" "\0"
  /* 13311 */ "SVGTransform" "\0"
  /* 13324 */ "SVGTransformList" "\0"
  /* 13341 */ "SVGUnitTypes" "\0"
  /* 13354 */ "SVGUseElement" "\0"
  /* 13368 */ "SVGViewElement" "\0"
  /* 13383 */ "Sanitizer" "\0"
  /* 13393 */ "Scheduler" "\0"
  /* 13403 */ "Screen" "\0"
  /* 13410 */ "ScreenLuminance" "\0"
  /* 13426 */ "ScreenOrientation" "\0"
  /* 13444 */ "ScriptProcessorNode" "\0"
  /* 13464 */ "ScrollAreaEvent" "\0"
  /* 13480 */ "ScrollViewChangeEvent" "\0"
  /* 13502 */ "SecurityPolicyViolationEvent" "\0"
  /* 13531 */ "Selection" "\0"
  /* 13541 */ "ServiceWorker" "\0"
  /* 13555 */ "ServiceWorkerContainer" "\0"
  /* 13578 */ "ServiceWorkerGlobalScope" "\0"
  /* 13603 */ "ServiceWorkerRegistration" "\0"
  /* 13629 */ "SessionStoreFormData" "\0"
  /* 13650 */ "SessionStoreScrollData" "\0"
  /* 13673 */ "SessionStoreUtils" "\0"
  /* 13691 */ "ShadowRealmGlobalScope" "\0"
  /* 13714 */ "ShadowRoot" "\0"
  /* 13725 */ "SharedWorker" "\0"
  /* 13738 */ "SharedWorkerGlobalScope" "\0"
  /* 13762 */ "SimpleGestureEvent" "\0"
  /* 13781 */ "SourceBuffer" "\0"
  /* 13794 */ "SourceBufferList" "\0"
  /* 13811 */ "SpeechGrammar" "\0"
  /* 13825 */ "SpeechGrammarList" "\0"
  /* 13843 */ "SpeechRecognition" "\0"
  /* 13861 */ "SpeechRecognitionAlternative" "\0"
  /* 13890 */ "SpeechRecognitionError" "\0"
  /* 13913 */ "SpeechRecognitionEvent" "\0"
  /* 13936 */ "SpeechRecognitionResult" "\0"
  /* 13960 */ "SpeechRecognitionResultList" "\0"
  /* 13988 */ "SpeechSynthesis" "\0"
  /* 14004 */ "SpeechSynthesisErrorEvent" "\0"
  /* 14030 */ "SpeechSynthesisEvent" "\0"
  /* 14051 */ "SpeechSynthesisUtterance" "\0"
  /* 14076 */ "SpeechSynthesisVoice" "\0"
  /* 14097 */ "StaticRange" "\0"
  /* 14109 */ "StereoPannerNode" "\0"
  /* 14126 */ "Storage" "\0"
  /* 14134 */ "StorageEvent" "\0"
  /* 14147 */ "StorageManager" "\0"
  /* 14162 */ "StreamFilter" "\0"
  /* 14175 */ "StreamFilterDataEvent" "\0"
  /* 14197 */ "StructuredCloneHolder" "\0"
  /* 14219 */ "StructuredCloneTester" "\0"
  /* 14241 */ "StyleSheet" "\0"
  /* 14252 */ "StyleSheetApplicableStateChangeEvent" "\0"
  /* 14289 */ "StyleSheetList" "\0"
  /* 14304 */ "SubmitEvent" "\0"
  /* 14316 */ "SubtleCrypto" "\0"
  /* 14329 */ "SyncMessageSender" "\0"
  /* 14347 */ "SyncReadFile" "\0"
  /* 14360 */ "TCPServerSocket" "\0"
  /* 14376 */ "TCPServerSocketEvent" "\0"
  /* 14397 */ "TCPSocket" "\0"
  /* 14407 */ "TCPSocketErrorEvent" "\0"
  /* 14427 */ "TCPSocketEvent" "\0"
  /* 14442 */ "TaskController" "\0"
  /* 14457 */ "TaskPriorityChangeEvent" "\0"
  /* 14481 */ "TaskSignal" "\0"
  /* 14492 */ "TelemetryStopwatch" "\0"
  /* 14511 */ "TestAttributesOnTypes" "\0"
  /* 14533 */ "TestCEReactionsInterface" "\0"
  /* 14558 */ "TestCImplementedInterface" "\0"
  /* 14584 */ "TestCImplementedInterface2" "\0"
  /* 14611 */ "TestChildInterface" "\0"
  /* 14630 */ "TestConstructorForFuncInterface" "\0"
  /* 14662 */ "TestConstructorForPrefInterface" "\0"
  /* 14694 */ "TestConstructorForSCInterface" "\0"
  /* 14724 */ "TestCppKeywordNamedMethodsInterface" "\0"
  /* 14760 */ "TestDeprecatedInterface" "\0"
  /* 14784 */ "TestExampleInterface" "\0"
  /* 14805 */ "TestExampleProxyInterface" "\0"
  /* 14831 */ "TestExampleThrowingConstructorInterface" "\0"
  /* 14871 */ "TestExampleWorkerInterface" "\0"
  /* 14898 */ "TestFuncConstructorForDifferentFuncInterface" "\0"
  /* 14943 */ "TestFuncConstructorForInterface" "\0"
  /* 14975 */ "TestHTMLConstructorInterface" "\0"
  /* 15004 */ "TestIndexedAndNamedGetterAndSetterInterface" "\0"
  /* 15048 */ "TestIndexedAndNamedGetterInterface" "\0"
  /* 15083 */ "TestIndexedAndNamedSetterInterface" "\0"
  /* 15118 */ "TestIndexedGetterAndSetterAndNamedGetterInterface" "\0"
  /* 15168 */ "TestIndexedGetterInterface" "\0"
  /* 15195 */ "TestIndexedSetterInterface" "\0"
  /* 15222 */ "TestInterface" "\0"
  /* 15236 */ "TestInterfaceWithPromiseConstructorArg" "\0"
  /* 15275 */ "TestJSImplInterface" "\0"
  /* 15295 */ "TestJSImplInterface2" "\0"
  /* 15316 */ "TestJSImplInterface3" "\0"
  /* 15337 */ "TestJSImplInterface4" "\0"
  /* 15358 */ "TestJSImplInterface5" "\0"
  /* 15379 */ "TestJSImplInterface6" "\0"
  /* 15400 */ "TestJSImplNoInterfaceObject" "\0"
  /* 15428 */ "TestNamedDeleterInterface" "\0"
  /* 15454 */ "TestNamedDeleterWithRetvalInterface" "\0"
  /* 15490 */ "TestNamedGetterInterface" "\0"
  /* 15515 */ "TestNamedSetterInterface" "\0"
  /* 15540 */ "TestNamespace" "\0"
  /* 15554 */ "TestNonWrapperCacheInterface" "\0"
  /* 15583 */ "TestParentInterface" "\0"
  /* 15603 */ "TestPrefChromeOnlySCFuncConstructorForInterface" "\0"
  /* 15651 */ "TestPrefConstructorForDifferentPrefInterface" "\0"
  /* 15696 */ "TestPrefConstructorForInterface" "\0"
  /* 15728 */ "TestProtoObjectHackedNamespace" "\0"
  /* 15759 */ "TestRenamedInterface" "\0"
  /* 15780 */ "TestRenamedNamespace" "\0"
  /* 15801 */ "TestSCConstructorForInterface" "\0"
  /* 15831 */ "TestSecureContextInterface" "\0"
  /* 15858 */ "TestThrowingConstructorInterface" "\0"
  /* 15891 */ "TestUtils" "\0"
  /* 15901 */ "TestWorkerExposedInterface" "\0"
  /* 15928 */ "TestingDeprecatedInterface" "\0"
  /* 15955 */ "Text" "\0"
  /* 15960 */ "TextClause" "\0"
  /* 15971 */ "TextDecoder" "\0"
  /* 15983 */ "TextDecoderStream" "\0"
  /* 16001 */ "TextEncoder" "\0"
  /* 16013 */ "TextEncoderStream" "\0"
  /* 16031 */ "TextMetrics" "\0"
  /* 16043 */ "TextTrack" "\0"
  /* 16053 */ "TextTrackCue" "\0"
  /* 16066 */ "TextTrackCueList" "\0"
  /* 16083 */ "TextTrackList" "\0"
  /* 16097 */ "TimeEvent" "\0"
  /* 16107 */ "TimeRanges" "\0"
  /* 16118 */ "ToggleEvent" "\0"
  /* 16130 */ "Touch" "\0"
  /* 16136 */ "TouchEvent" "\0"
  /* 16147 */ "TouchList" "\0"
  /* 16157 */ "TrackEvent" "\0"
  /* 16168 */ "TransformStream" "\0"
  /* 16184 */ "TransformStreamDefaultController" "\0"
  /* 16217 */ "TransitionEvent" "\0"
  /* 16233 */ "TreeColumn" "\0"
  /* 16244 */ "TreeColumns" "\0"
  /* 16256 */ "TreeContentView" "\0"
  /* 16272 */ "TreeWalker" "\0"
  /* 16283 */ "UDPMessageEvent" "\0"
  /* 16299 */ "UDPSocket" "\0"
  /* 16309 */ "UIEvent" "\0"
  /* 16317 */ "URL" "\0"
  /* 16321 */ "URLSearchParams" "\0"
  /* 16337 */ "URLSearchParams Iterator" "\0"
  /* 16362 */ "UniFFIPointer" "\0"
  /* 16376 */ "UniFFIScaffolding" "\0"
  /* 16394 */ "UserInteraction" "\0"
  /* 16410 */ "UserProximityEvent" "\0"
  /* 16429 */ "VRDisplay" "\0"
  /* 16439 */ "VRDisplayCapabilities" "\0"
  /* 16461 */ "VRDisplayEvent" "\0"
  /* 16476 */ "VREyeParameters" "\0"
  /* 16492 */ "VRFieldOfView" "\0"
  /* 16506 */ "VRFrameData" "\0"
  /* 16518 */ "VRMockController" "\0"
  /* 16535 */ "VRMockDisplay" "\0"
  /* 16549 */ "VRPose" "\0"
  /* 16556 */ "VRServiceTest" "\0"
  /* 16570 */ "VRStageParameters" "\0"
  /* 16588 */ "VTTCue" "\0"
  /* 16595 */ "VTTRegion" "\0"
  /* 16605 */ "ValidityState" "\0"
  /* 16619 */ "VideoColorSpace" "\0"
  /* 16635 */ "VideoDecoder" "\0"
  /* 16648 */ "VideoFrame" "\0"
  /* 16659 */ "VideoPlaybackQuality" "\0"
  /* 16680 */ "VideoTrack" "\0"
  /* 16691 */ "VideoTrackList" "\0"
  /* 16706 */ "VisualViewport" "\0"
  /* 16721 */ "WEBGL_color_buffer_float" "\0"
  /* 16746 */ "WEBGL_compressed_texture_astc" "\0"
  /* 16776 */ "WEBGL_compressed_texture_etc" "\0"
  /* 16805 */ "WEBGL_compressed_texture_etc1" "\0"
  /* 16835 */ "WEBGL_compressed_texture_pvrtc" "\0"
  /* 16866 */ "WEBGL_compressed_texture_s3tc" "\0"
  /* 16896 */ "WEBGL_compressed_texture_s3tc_srgb" "\0"
  /* 16931 */ "WEBGL_debug_renderer_info" "\0"
  /* 16957 */ "WEBGL_debug_shaders" "\0"
  /* 16977 */ "WEBGL_depth_texture" "\0"
  /* 16997 */ "WEBGL_draw_buffers" "\0"
  /* 17016 */ "WEBGL_explicit_present" "\0"
  /* 17039 */ "WEBGL_lose_context" "\0"
  /* 17058 */ "WEBGL_provoking_vertex" "\0"
  /* 17081 */ "WaveShaperNode" "\0"
  /* 17096 */ "WebExtensionContentScript" "\0"
  /* 17122 */ "WebExtensionPolicy" "\0"
  /* 17141 */ "WebGL2RenderingContext" "\0"
  /* 17164 */ "WebGLActiveInfo" "\0"
  /* 17180 */ "WebGLBuffer" "\0"
  /* 17192 */ "WebGLContextEvent" "\0"
  /* 17210 */ "WebGLFramebuffer" "\0"
  /* 17227 */ "WebGLProgram" "\0"
  /* 17240 */ "WebGLQuery" "\0"
  /* 17251 */ "WebGLRenderbuffer" "\0"
  /* 17269 */ "WebGLRenderingContext" "\0"
  /* 17291 */ "WebGLSampler" "\0"
  /* 17304 */ "WebGLShader" "\0"
  /* 17316 */ "WebGLShaderPrecisionFormat" "\0"
  /* 17343 */ "WebGLSync" "\0"
  /* 17353 */ "WebGLTexture" "\0"
  /* 17366 */ "WebGLTransformFeedback" "\0"
  /* 17389 */ "WebGLUniformLocation" "\0"
  /* 17410 */ "WebGLVertexArrayObject" "\0"
  /* 17433 */ "WebKitCSSMatrix" "\0"
  /* 17449 */ "WebSocket" "\0"
  /* 17459 */ "WebTransport" "\0"
  /* 17472 */ "WebTransportBidirectionalStream" "\0"
  /* 17504 */ "WebTransportDatagramDuplexStream" "\0"
  /* 17537 */ "WebTransportError" "\0"
  /* 17555 */ "WebTransportReceiveStream" "\0"
  /* 17581 */ "WebTransportSendStream" "\0"
  /* 17604 */ "WebrtcGlobalInformation" "\0"
  /* 17628 */ "WheelEvent" "\0"
  /* 17639 */ "Window" "\0"
  /* 17646 */ "WindowClient" "\0"
  /* 17659 */ "WindowContext" "\0"
  /* 17673 */ "WindowGlobalChild" "\0"
  /* 17691 */ "WindowGlobalParent" "\0"
  /* 17710 */ "WindowRoot" "\0"
  /* 17721 */ "Worker" "\0"
  /* 17728 */ "WorkerDebuggerGlobalScope" "\0"
  /* 17754 */ "WorkerGlobalScope" "\0"
  /* 17772 */ "WorkerLocation" "\0"
  /* 17787 */ "WorkerNavigator" "\0"
  /* 17803 */ "WorkerTestUtils" "\0"
  /* 17819 */ "Worklet" "\0"
  /* 17827 */ "WorkletGlobalScope" "\0"
  /* 17846 */ "WritableStream" "\0"
  /* 17861 */ "WritableStreamDefaultController" "\0"
  /* 17893 */ "WritableStreamDefaultWriter" "\0"
  /* 17921 */ "XMLDocument" "\0"
  /* 17933 */ "XMLHttpRequest" "\0"
  /* 17948 */ "XMLHttpRequestEventTarget" "\0"
  /* 17974 */ "XMLHttpRequestUpload" "\0"
  /* 17995 */ "XMLSerializer" "\0"
  /* 18009 */ "XPathEvaluator" "\0"
  /* 18024 */ "XPathExpression" "\0"
  /* 18040 */ "XPathResult" "\0"
  /* 18052 */ "XRBoundedReferenceSpace" "\0"
  /* 18076 */ "XRFrame" "\0"
  /* 18084 */ "XRInputSource" "\0"
  /* 18098 */ "XRInputSourceArray" "\0"
  /* 18117 */ "XRInputSourceEvent" "\0"
  /* 18136 */ "XRInputSourcesChangeEvent" "\0"
  /* 18162 */ "XRPose" "\0"
  /* 18169 */ "XRReferenceSpace" "\0"
  /* 18186 */ "XRReferenceSpaceEvent" "\0"
  /* 18208 */ "XRRenderState" "\0"
  /* 18222 */ "XRRigidTransform" "\0"
  /* 18239 */ "XRSession" "\0"
  /* 18249 */ "XRSessionEvent" "\0"
  /* 18264 */ "XRSpace" "\0"
  /* 18272 */ "XRSystem" "\0"
  /* 18281 */ "XRView" "\0"
  /* 18288 */ "XRViewerPose" "\0"
  /* 18301 */ "XRViewport" "\0"
  /* 18312 */ "XRWebGLLayer" "\0"
  /* 18325 */ "XSLTProcessor" "\0"
  /* 18339 */ "XULCommandEvent" "\0"
  /* 18355 */ "XULElement" "\0"
  /* 18366 */ "XULFrameElement" "\0"
  /* 18382 */ "XULMenuElement" "\0"
  /* 18397 */ "XULPopupElement" "\0"
  /* 18413 */ "XULResizerElement" "\0"
  /* 18431 */ "XULTextElement" "\0"
  /* 18446 */ "XULTreeElement" "\0"
  /* 18461 */ "console" "\0"
  /* 18469 */ "webkitSpeechGrammar" "\0"
  /* 18489 */ "webkitSpeechGrammarList" "\0"
  /* 18513 */ "webkitSpeechRecognition" "\0"
  /* 18537 */ "webkitURL"
};

}  // namespace binding_detail

// Making this enum bigger than a uint16_t has consequences on the size
// of some structs (eg. WebIDLNameTableEntry) and tables. We should try
// to avoid that.
static_assert(EnumTypeFitsWithin<BindingNamesOffset, uint16_t>::value,
              "Size increase");

} // namespace mozilla::dom

