/// AUTO GENERATED BY build.rs

use std::collections::HashMap;

use webrender_build::shader::ShaderVersion;

pub struct SourceWithDigest {
    pub source: &'static str,
    pub digest: &'static str,
}

pub struct OptimizedSourceWithDigest {
    pub vert_source: &'static str,
    pub frag_source: &'static str,
    pub digest: &'static str,
}

lazy_static! {
  pub static ref UNOPTIMIZED_SHADERS: HashMap<&'static str, SourceWithDigest> = {
    let mut shaders = HashMap::new();
    shaders.insert("base", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/base.glsl"), digest: "d5ae695bab268b7d"});
    shaders.insert("blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/blend.glsl"), digest: "c24d37103d7732b9"});
    shaders.insert("brush", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/brush.glsl"), digest: "fc30fd1ae0df270f"});
    shaders.insert("brush_blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/brush_blend.glsl"), digest: "ae6899aa79861a1c"});
    shaders.insert("brush_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/brush_image.glsl"), digest: "a73414e6fe86fee3"});
    shaders.insert("brush_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/brush_linear_gradient.glsl"), digest: "77f10d435861f17e"});
    shaders.insert("brush_mix_blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/brush_mix_blend.glsl"), digest: "e3a209200f48f314"});
    shaders.insert("brush_opacity", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/brush_opacity.glsl"), digest: "1a8e3cbccca1780"});
    shaders.insert("brush_solid", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/brush_solid.glsl"), digest: "ddd6414c35774b5a"});
    shaders.insert("brush_yuv_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/brush_yuv_image.glsl"), digest: "57a520995d96118f"});
    shaders.insert("clip_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/clip_shared.glsl"), digest: "6ff98586e3e3cd56"});
    shaders.insert("composite", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/composite.glsl"), digest: "8fb0134fec23a2f"});
    shaders.insert("cs_blur", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/cs_blur.glsl"), digest: "979cc90726821721"});
    shaders.insert("cs_border_segment", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/cs_border_segment.glsl"), digest: "67b283074939118"});
    shaders.insert("cs_border_solid", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/cs_border_solid.glsl"), digest: "1d09a71842ebca07"});
    shaders.insert("cs_clip_box_shadow", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/cs_clip_box_shadow.glsl"), digest: "ecba94e85798a75d"});
    shaders.insert("cs_clip_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/cs_clip_image.glsl"), digest: "46cd180fed879c08"});
    shaders.insert("cs_clip_rectangle", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/cs_clip_rectangle.glsl"), digest: "af69f3a950578f36"});
    shaders.insert("cs_conic_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/cs_conic_gradient.glsl"), digest: "9c161f775bd8bba0"});
    shaders.insert("cs_fast_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/cs_fast_linear_gradient.glsl"), digest: "ef9f1ccfb810fcb7"});
    shaders.insert("cs_line_decoration", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/cs_line_decoration.glsl"), digest: "d748c3c2d07cd5f7"});
    shaders.insert("cs_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/cs_linear_gradient.glsl"), digest: "e14c0e2ce7d1f2c7"});
    shaders.insert("cs_radial_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/cs_radial_gradient.glsl"), digest: "bc6777d38b3b8cb5"});
    shaders.insert("cs_scale", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/cs_scale.glsl"), digest: "61e87702cea2fa74"});
    shaders.insert("cs_svg_filter", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/cs_svg_filter.glsl"), digest: "5ee862a64046e366"});
    shaders.insert("debug_color", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/debug_color.glsl"), digest: "4efb42475715bac6"});
    shaders.insert("debug_font", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/debug_font.glsl"), digest: "7d1cfdd8e4f6c69d"});
    shaders.insert("ellipse", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/ellipse.glsl"), digest: "951dc637533b8416"});
    shaders.insert("gpu_buffer", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/gpu_buffer.glsl"), digest: "f7046c285ef0b3d1"});
    shaders.insert("gpu_cache", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/gpu_cache.glsl"), digest: "e99b57d9cc26406a"});
    shaders.insert("gpu_cache_update", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/gpu_cache_update.glsl"), digest: "4ad2e4e46e03b7c2"});
    shaders.insert("gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/gradient.glsl"), digest: "993c4122e49f3fef"});
    shaders.insert("gradient_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/gradient_shared.glsl"), digest: "c7765e50322898d6"});
    shaders.insert("prim_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/prim_shared.glsl"), digest: "565007465722b8d8"});
    shaders.insert("ps_clear", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/ps_clear.glsl"), digest: "1e8994ed1acbdc13"});
    shaders.insert("ps_copy", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/ps_copy.glsl"), digest: "f0e76514309bd9fa"});
    shaders.insert("ps_quad", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/ps_quad.glsl"), digest: "73f47259ef986957"});
    shaders.insert("ps_quad_mask", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/ps_quad_mask.glsl"), digest: "4396664163937bc7"});
    shaders.insert("ps_quad_textured", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/ps_quad_textured.glsl"), digest: "13a9581cc0a8fbf0"});
    shaders.insert("ps_split_composite", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/ps_split_composite.glsl"), digest: "7b5e9e559a0e142c"});
    shaders.insert("ps_text_run", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/ps_text_run.glsl"), digest: "a007ceefc49d65ad"});
    shaders.insert("rect", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/rect.glsl"), digest: "a072b75695c59cf6"});
    shaders.insert("render_task", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/render_task.glsl"), digest: "c4574b7a23485833"});
    shaders.insert("shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/shared.glsl"), digest: "df523dc077d5bcbf"});
    shaders.insert("shared_other", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/shared_other.glsl"), digest: "9f6298a27dfe79c6"});
    shaders.insert("transform", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/transform.glsl"), digest: "35a01bc6ab4b6f5a"});
    shaders.insert("yuv", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-117.0.1/gfx/wr/webrender/res/yuv.glsl"), digest: "6ddbed9adc2b29d"});
    shaders
  };

  pub static ref OPTIMIZED_SHADERS: HashMap<(ShaderVersion, &'static str), OptimizedSourceWithDigest> = {
    let mut shaders = HashMap::new();
    shaders.insert((ShaderVersion::Gl, "brush_blend"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_blend_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_blend_Gl.frag"),
        digest: "8058a66620365a7d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_blend_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_blend_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_blend_ALPHA_PASS_Gl.frag"),
        digest: "afb96409527d0d21",
    });
    shaders.insert((ShaderVersion::Gl, "brush_blend_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_blend_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_blend_DEBUG_OVERDRAW_Gl.frag"),
        digest: "54279562e22cb9e",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "d204ad545ff0b6c8",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "d68f1c0be3148f8e",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "86108f12c8b4c14f",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT_Gl.frag"),
        digest: "7e89b269741cf434",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "264274b3c8433987",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "731ea7103221ad0e",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "d603ae37b268b0c2",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "dc63ad960b1f4822",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "adf62c244e674a92",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT_Gl.frag"),
        digest: "842a9aa5b15887e5",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "f393b2f5d8b9cecc",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ALPHA_PASS_TEXTURE_RECT_Gl.frag"),
        digest: "4bc971dd140ecaad",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "335a5a3f5f90b6d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "8b3d5cfc4cdcef6c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "a61b84f3a9e723df",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "37888f72239d5cd2",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_DEBUG_OVERDRAW_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_DEBUG_OVERDRAW_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_DEBUG_OVERDRAW_TEXTURE_2D_Gl.frag"),
        digest: "d61107e5696e96d3",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_DEBUG_OVERDRAW_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_DEBUG_OVERDRAW_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_DEBUG_OVERDRAW_TEXTURE_RECT_Gl.frag"),
        digest: "75a261f88b8e4e55",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_TEXTURE_2D_Gl.frag"),
        digest: "2e5428a23906736f",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_image_TEXTURE_RECT_Gl.frag"),
        digest: "46ec8f727cf44a7c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_linear_gradient_Gl.frag"),
        digest: "cc3c5d5c2837cd49",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_linear_gradient_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_linear_gradient_ALPHA_PASS_Gl.frag"),
        digest: "6c417f344466a4c7",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_linear_gradient_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_linear_gradient_DEBUG_OVERDRAW_Gl.frag"),
        digest: "f4ab5ba9c81afee0",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_mix_blend_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_mix_blend_Gl.frag"),
        digest: "fb5fd955bc7c5461",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_mix_blend_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_mix_blend_ALPHA_PASS_Gl.frag"),
        digest: "33f4fedaf2f70eb8",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_mix_blend_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_mix_blend_DEBUG_OVERDRAW_Gl.frag"),
        digest: "b216aa79f7c6c0e6",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_opacity_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_opacity_Gl.frag"),
        digest: "48473ad901edd695",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_opacity_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_opacity_ALPHA_PASS_Gl.frag"),
        digest: "ade7a531aa0fb34a",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ALPHA_PASS_ANTIALIASING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_opacity_ALPHA_PASS_ANTIALIASING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_opacity_ALPHA_PASS_ANTIALIASING_Gl.frag"),
        digest: "d811883989d3bb6c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ANTIALIASING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_opacity_ANTIALIASING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_opacity_ANTIALIASING_Gl.frag"),
        digest: "74908305a20abd78",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ANTIALIASING_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_opacity_ANTIALIASING_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_opacity_ANTIALIASING_DEBUG_OVERDRAW_Gl.frag"),
        digest: "7895d6dfb6d67967",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_opacity_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_opacity_DEBUG_OVERDRAW_Gl.frag"),
        digest: "2d82259b9569ed98",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_solid_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_solid_Gl.frag"),
        digest: "c8bb2fae2850c2d7",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_solid_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_solid_ALPHA_PASS_Gl.frag"),
        digest: "ba5e8cd20a02c43d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_solid_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_solid_DEBUG_OVERDRAW_Gl.frag"),
        digest: "2a3f232b8a513101",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV_Gl.frag"),
        digest: "9e1b445f09de1f62",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "f25211984e132749",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV_Gl.frag"),
        digest: "f86a55819b9eb5a4",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "64f2cf1eae606759",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_yuv_image_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_yuv_image_TEXTURE_2D_YUV_Gl.frag"),
        digest: "479f551dc7a6b275",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_yuv_image_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/brush_yuv_image_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "39a196d0c22bf291",
    });
    shaders.insert((ShaderVersion::Gl, "composite_FAST_PATH_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/composite_FAST_PATH_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/composite_FAST_PATH_TEXTURE_2D_Gl.frag"),
        digest: "b4abdac35adeca92",
    });
    shaders.insert((ShaderVersion::Gl, "composite_FAST_PATH_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/composite_FAST_PATH_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/composite_FAST_PATH_TEXTURE_RECT_Gl.frag"),
        digest: "4ed90b4b39c4d003",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/composite_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/composite_TEXTURE_2D_Gl.frag"),
        digest: "49e6f09ccfcebfab",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/composite_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/composite_TEXTURE_2D_YUV_Gl.frag"),
        digest: "ff94e6c0fe6293bd",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/composite_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/composite_TEXTURE_RECT_Gl.frag"),
        digest: "759b8621deb43f74",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/composite_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/composite_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "f10fba04f7c59437",
    });
    shaders.insert((ShaderVersion::Gl, "cs_blur_ALPHA_TARGET"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_blur_ALPHA_TARGET_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_blur_ALPHA_TARGET_Gl.frag"),
        digest: "e1ee6b18274ebea4",
    });
    shaders.insert((ShaderVersion::Gl, "cs_blur_COLOR_TARGET"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_blur_COLOR_TARGET_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_blur_COLOR_TARGET_Gl.frag"),
        digest: "44b296e917f5ffe0",
    });
    shaders.insert((ShaderVersion::Gl, "cs_border_segment"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_border_segment_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_border_segment_Gl.frag"),
        digest: "8495134f5ed37bf5",
    });
    shaders.insert((ShaderVersion::Gl, "cs_border_solid"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_border_solid_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_border_solid_Gl.frag"),
        digest: "9fd688a8c266d2da",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_box_shadow_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_clip_box_shadow_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_clip_box_shadow_TEXTURE_2D_Gl.frag"),
        digest: "9f76c2a874c97310",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_image_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_clip_image_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_clip_image_TEXTURE_2D_Gl.frag"),
        digest: "b69a0fd2c6027778",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_rectangle"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_clip_rectangle_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_clip_rectangle_Gl.frag"),
        digest: "cabc2ef7edf7bd12",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_rectangle_FAST_PATH"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_clip_rectangle_FAST_PATH_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_clip_rectangle_FAST_PATH_Gl.frag"),
        digest: "2504a7e464e09644",
    });
    shaders.insert((ShaderVersion::Gl, "cs_conic_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_conic_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_conic_gradient_Gl.frag"),
        digest: "653ad09c4b159697",
    });
    shaders.insert((ShaderVersion::Gl, "cs_fast_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_fast_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_fast_linear_gradient_Gl.frag"),
        digest: "3d4ec20a2b40f905",
    });
    shaders.insert((ShaderVersion::Gl, "cs_line_decoration"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_line_decoration_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_line_decoration_Gl.frag"),
        digest: "7943c68da0973c69",
    });
    shaders.insert((ShaderVersion::Gl, "cs_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_linear_gradient_Gl.frag"),
        digest: "ec6e7a133cbb1999",
    });
    shaders.insert((ShaderVersion::Gl, "cs_radial_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_radial_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_radial_gradient_Gl.frag"),
        digest: "ac62439ba9ff459c",
    });
    shaders.insert((ShaderVersion::Gl, "cs_scale_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_scale_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_scale_TEXTURE_2D_Gl.frag"),
        digest: "d30639d4f078578d",
    });
    shaders.insert((ShaderVersion::Gl, "cs_scale_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_scale_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_scale_TEXTURE_RECT_Gl.frag"),
        digest: "29422e04bd4ba508",
    });
    shaders.insert((ShaderVersion::Gl, "cs_svg_filter"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_svg_filter_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/cs_svg_filter_Gl.frag"),
        digest: "aca9420acaec4776",
    });
    shaders.insert((ShaderVersion::Gl, "debug_color"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/debug_color_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/debug_color_Gl.frag"),
        digest: "f458fe7ea40bd77e",
    });
    shaders.insert((ShaderVersion::Gl, "debug_font"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/debug_font_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/debug_font_Gl.frag"),
        digest: "503ec56c19b6bd2c",
    });
    shaders.insert((ShaderVersion::Gl, "ps_clear"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_clear_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_clear_Gl.frag"),
        digest: "9ef2acc3bbd621e8",
    });
    shaders.insert((ShaderVersion::Gl, "ps_copy"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_copy_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_copy_Gl.frag"),
        digest: "514726576460ee72",
    });
    shaders.insert((ShaderVersion::Gl, "ps_quad_mask"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_quad_mask_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_quad_mask_Gl.frag"),
        digest: "e61aa03e87a6242b",
    });
    shaders.insert((ShaderVersion::Gl, "ps_quad_mask_FAST_PATH"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_quad_mask_FAST_PATH_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_quad_mask_FAST_PATH_Gl.frag"),
        digest: "d3fb11f8b471801",
    });
    shaders.insert((ShaderVersion::Gl, "ps_quad_textured"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_quad_textured_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_quad_textured_Gl.frag"),
        digest: "b0dc2be75c57b4e6",
    });
    shaders.insert((ShaderVersion::Gl, "ps_split_composite"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_split_composite_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_split_composite_Gl.frag"),
        digest: "9c48e025688a9b51",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D_Gl.frag"),
        digest: "8bff6bcffbebd6ad",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "dd575950a903c8ba",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D_Gl.frag"),
        digest: "4d6e30fc06596570",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_text_run_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_text_run_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "3b19da76a889ee4e",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "4aae4ef3ece9362a",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-117.0.1/objdir/x86_64-unknown-linux-gnu/release/build/webrender-4722fe62b395b47e/out/ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D_Gl.frag"),
        digest: "cead4141c1fe587c",
    });
    shaders
  };
}
